# MSN-Redirect
This is a browser extension that will redirect you from a news article re-posted on MSN to the original article from the author's original site.

## Why?
MSN lets you read articles from other news outlets on the MSN site. Some people are fine with this, but others (me included) would rather read the article from the original author's/publication's website. For me it's mainly because I don't like MSN's UI, (or really Microsoft's stuff in general) and I'd just rather read a publication's article on it's original site. However, MSN doesn't let you do this easily. They show who originally published it, and how to get to their home page, but don't have any way to get to the original article. Sure, you could just not go to MSN, but in some news apps or search engines, the MSN articles are indexed instead of or ahead of the original article. I found this annoying, and so do other people from what I've seen on Reddit, so I decided to write this extension.

## How does it work?
It's a simple redirect extension (based on the examples from [Mozilla Developers Network](https://developer.mozilla.org/en-US/docs/Mozilla/Add-ons/WebExtensions/Intercept_HTTP_requests)) that intercepts http requests, checks to see if the url is from MSN, and runs a redirect function. Since the original article isn't linked, and URL schemes tend to differ between MSN and the original publisher, I get the original article's URL through a DuckDuckGo dork that pulls up the original article as the first (and usually only) article option. Then, I scrape the results, do some parsing, and extract the original URL.

## To Do List
Here's kind of a roadmap of stuff I need to do with this.
- [X] Basic Functionality: Detects if a link is for an MSN article, finds a link from the title, and redirects.
- [X] Isolate only to articles: I got it reasonably working so other non-news aspects of MSN work for those who might still want that.
- [ ] Link accuracy: It currently pulls an article, but sometimes it isn't the right one. I'm trying to find a way to extract the original site url from MSN, but it isn't as easy as a normal scrape.
- [ ] Add UI: Make it possible to toggle between original and MSN, and add some control for the user.